Index: issm/trunk/src/c/analyses/StressbalanceAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/StressbalanceAnalysis.cpp	(revision 18081)
+++ issm/trunk/src/c/analyses/StressbalanceAnalysis.cpp	(revision 18301)
@@ -3972,18 +4623,96 @@
 			B[(vnumdof+pnumdof)*1+3*i+1] = vbasis[i];
 			B[(vnumdof+pnumdof)*1+3*i+2] = 0.;
+
+			B[(vnumdof+pnumdof)*2+3*i+0] = 0.;
+			B[(vnumdof+pnumdof)*2+3*i+1] = 0.;
+			B[(vnumdof+pnumdof)*2+3*i+2] = vbasis[i];
 		}
 		for(int i=0;i<pnumnodes;i++){
 			B[(vnumdof+pnumdof)*0+i+vnumdof+0] = 0.;
 			B[(vnumdof+pnumdof)*1+i+vnumdof+0] = 0.;
+			B[(vnumdof+pnumdof)*2+i+vnumdof+0] = 0.;
 		}
 	}
 	else{
 		for(int i=0;i<vnumnodes;i++){
-			B[2*i+0] = vbasis[i];
-			B[2*i+1] = 0.;
+			B[(vnumdof+pnumdof)*0+2*i+0] = vbasis[i];
+			B[(vnumdof+pnumdof)*0+2*i+1] = 0.;
+
+			B[(vnumdof+pnumdof)*1+2*i+0] = 0.;
+			B[(vnumdof+pnumdof)*1+2*i+1] = vbasis[i];
 		}
 
 		for(int i=0;i<pnumnodes;i++){
-			B[i+vnumdof+0] = 0.;
+			B[(vnumdof+pnumdof)*0+i+vnumdof+0] = 0.;
+			B[(vnumdof+pnumdof)*1+i+vnumdof+0] = 0.;
+		}
+	}
+
+	/*Clean-up*/
+	xDelete<IssmDouble>(vbasis);
+}/*}}}*/
+void StressbalanceAnalysis::GetCFS(IssmDouble* C,Element* element,int dim,IssmDouble* xyz_list,Gauss* gauss){/*{{{*/
+	/*Compute C  matrix. C=[Cp1 Cp2 ...] where:
+	 *     Cpi=[phi phi]. 
+	 */
+
+	/*Fetch number of nodes for this finite element*/
+	int lnumnodes = element->GetNumberOfNodes(P2Enum);
+
+	/*Get nodal functions derivatives*/
+	IssmDouble* basis =xNew<IssmDouble>(lnumnodes);
+	element->NodalFunctionsP2(basis,gauss);
+
+	/*Build B: */
+	for(int i=0;i<lnumnodes;i++){
+		C[lnumnodes*0+i] = basis[i];
+		C[lnumnodes*1+i] = basis[i];
+	}
+
+	/*Clean up*/
+	xDelete<IssmDouble>(basis);
+}/*}}}*/
+void StressbalanceAnalysis::GetCFSprime(IssmDouble* Cprime,Element* element,int dim,IssmDouble* xyz_list,Gauss* gauss){/*{{{*/
+	/*	Compute C'  matrix. C'=[C1' C2' ...] 
+	 *			Ci' = [  phi  0  ]
+	 *			      [   0  phi ]
+	 *
+	 *	In 3d
+	 *			Ci' = [  phi  0   0  ]
+	 *			      [   0  phi  0  ]
+	 *			      [   0   0  phi ]
+	 *	where phi is the finiteelement function for node i.
+	 */
+
+	/*Fetch number of nodes for this finite element*/
+	int vnumnodes = element->NumberofNodesVelocity();
+	int vnumdof   = vnumnodes*dim;
+
+	IssmDouble* vbasis=xNew<IssmDouble>(vnumnodes);
+	element->NodalFunctionsVelocity(vbasis,gauss);
+
+	/*Build B: */
+	if(dim==3){
+		for(int i=0;i<vnumnodes;i++){
+			Cprime[vnumdof*0+3*i+0] = vbasis[i];
+			Cprime[vnumdof*0+3*i+1] = 0.;
+			Cprime[vnumdof*0+3*i+2] = 0.;
+
+			Cprime[vnumdof*1+3*i+0] = 0.;
+			Cprime[vnumdof*1+3*i+1] = vbasis[i];
+			Cprime[vnumdof*1+3*i+2] = 0.;
+
+			Cprime[vnumdof*2+3*i+0] = 0.;
+			Cprime[vnumdof*2+3*i+1] = 0.;
+			Cprime[vnumdof*2+3*i+2] = vbasis[i];
+		}
+	}
+	else{
+		for(int i=0;i<vnumnodes;i++){
+			Cprime[vnumdof*0+2*i+0] = vbasis[i];
+			Cprime[vnumdof*0+2*i+1] = 0.;
+
+			Cprime[vnumdof*1+2*i+0] = 0.;
+			Cprime[vnumdof*1+2*i+1] = vbasis[i];
 		}
 	}
@@ -4046,5 +4775,5 @@
 	/*Add value to global vector*/
 	solution->SetValues(vnumdof,vdoflist,vvalues,INS_VAL);
-	solution->SetValues(pnumdof,pdoflist,pvalues,INS_VAL);
+	if(pnumdof>0) solution->SetValues(pnumdof,pdoflist,pvalues,INS_VAL);
 
 	/*Free ressources:*/
@@ -4203,5 +4932,5 @@
 	element->InputChangeName(VxEnum,VxPicardEnum);
 	element->InputChangeName(VyEnum,VyPicardEnum);
-	element->InputChangeName(PressureEnum,PressurePicardEnum);
+	if(pnumdof>0) element->InputChangeName(PressureEnum,PressurePicardEnum);
 	if(dim==3) element->InputChangeName(VzEnum,VzPicardEnum);
 
@@ -4210,5 +4939,5 @@
 	element->AddInput(VyEnum,      vy,      element->VelocityInterpolation());
 	element->AddInput(VelEnum,     vel,     element->VelocityInterpolation());
-	element->AddInput(PressureEnum,pressure,element->PressureInterpolation());
+	if(pnumdof>0) element->AddInput(PressureEnum,pressure,element->PressureInterpolation());
 	if(dim==3) element->AddInput(VzEnum,vz, element->VelocityInterpolation());
 
@@ -4407,4 +5136,7 @@
 		else{
 			_assert_(tnumnodes==4);
+			d_zz = xNew<IssmDouble>(tnumnodes);
+			d_xz = xNew<IssmDouble>(tnumnodes);
+			d_yz = xNew<IssmDouble>(tnumnodes);
 			Matrix4x4Solve(&d_xx[0],Ke,pe_xx);
 			Matrix4x4Solve(&d_yy[0],Ke,pe_yy);
@@ -4457,5 +5189,5 @@
 		Input* vx_input=element->GetInput(VxEnum);                 _assert_(vx_input);
 		Input* vy_input=element->GetInput(VyEnum);                 _assert_(vy_input);
-		Input* vz_input;
+		Input* vz_input=NULL;
 		if(dim==3){vz_input=element->GetInput(VzEnum); _assert_(vz_input);}
 
@@ -4492,4 +5224,9 @@
 		IssmDouble* tau_xz = NULL;
 		IssmDouble* tau_yz = NULL;
+		if(dim==3){
+			tau_zz = xNew<IssmDouble>(tnumnodes);
+			tau_xz = xNew<IssmDouble>(tnumnodes);
+			tau_yz = xNew<IssmDouble>(tnumnodes);
+		}
 		Gauss* gauss = element->NewGauss();
 		for(int ig=0;ig<tnumnodes;ig++){
@@ -5811,5 +6548,5 @@
 
 	int num_dof=2;
-	IssmDouble L1L2l3[3];
+	IssmDouble basis[3];
 
 	/*Cast gauss to GaussPenta*/
@@ -5817,27 +6554,27 @@
 	GaussPenta* gauss = dynamic_cast<GaussPenta*>(gauss_in);
 
-	/*Get L1L2l3 in actual coordinate system: */
-	L1L2l3[0]=gauss->coord1*(1-gauss->coord4)/2.0;
-	L1L2l3[1]=gauss->coord2*(1-gauss->coord4)/2.0;
-	L1L2l3[2]=gauss->coord3*(1-gauss->coord4)/2.0;
+	/*Get basis in actual coordinate system: */
+	basis[0]=gauss->coord1*(1-gauss->coord4)/2.0;
+	basis[1]=gauss->coord2*(1-gauss->coord4)/2.0;
+	basis[2]=gauss->coord3*(1-gauss->coord4)/2.0;
 
 	/*Build LFS: */
 	for(int i=0;i<3;i++){
-		LFS[num_dof*3*0+num_dof*i+0] = L1L2l3[i];
+		LFS[num_dof*3*0+num_dof*i+0] = basis[i];
 		LFS[num_dof*3*0+num_dof*i+1] = 0;
 		LFS[num_dof*3*1+num_dof*i+0] = 0;
-		LFS[num_dof*3*1+num_dof*i+1] = L1L2l3[i];
-		LFS[num_dof*3*2+num_dof*i+0] = L1L2l3[i];
+		LFS[num_dof*3*1+num_dof*i+1] = basis[i];
+		LFS[num_dof*3*2+num_dof*i+0] = basis[i];
 		LFS[num_dof*3*2+num_dof*i+1] = 0;
 		LFS[num_dof*3*3+num_dof*i+0] = 0;
-		LFS[num_dof*3*3+num_dof*i+1] = L1L2l3[i];
-		LFS[num_dof*3*4+num_dof*i+0] = L1L2l3[i];
+		LFS[num_dof*3*3+num_dof*i+1] = basis[i];
+		LFS[num_dof*3*4+num_dof*i+0] = basis[i];
 		LFS[num_dof*3*4+num_dof*i+1] = 0;
 		LFS[num_dof*3*5+num_dof*i+0] = 0;
-		LFS[num_dof*3*5+num_dof*i+1] = L1L2l3[i];
-		LFS[num_dof*3*6+num_dof*i+0] = L1L2l3[i];
+		LFS[num_dof*3*5+num_dof*i+1] = basis[i];
+		LFS[num_dof*3*6+num_dof*i+0] = basis[i];
 		LFS[num_dof*3*6+num_dof*i+1] = 0;
 		LFS[num_dof*3*7+num_dof*i+0] = 0;
-		LFS[num_dof*3*7+num_dof*i+1] = L1L2l3[i];
+		LFS[num_dof*3*7+num_dof*i+1] = basis[i];
 	}
 }/*}}}*/
@@ -5859,5 +6596,5 @@
 	int num_dof_vel=3*7;
 	int num_dof_total=3*7+1*6;
-	IssmDouble L1L2l3[3];
+	IssmDouble basis[3];
 	IssmDouble dbasis[3][6];
 
@@ -5866,8 +6603,8 @@
 	GaussPenta* gauss = dynamic_cast<GaussPenta*>(gauss_in);
 
-	/*Get L1L2l3 in actual coordinate system: */
-	L1L2l3[0]=gauss->coord1*(1-gauss->coord4)/2.0;
-	L1L2l3[1]=gauss->coord2*(1-gauss->coord4)/2.0;
-	L1L2l3[2]=gauss->coord3*(1-gauss->coord4)/2.0;
+	/*Get basis in actual coordinate system: */
+	basis[0]=gauss->coord1*(1-gauss->coord4)/2.0;
+	basis[1]=gauss->coord2*(1-gauss->coord4)/2.0;
+	basis[2]=gauss->coord3*(1-gauss->coord4)/2.0;
 
 	element->NodalFunctionsP1Derivatives(&dbasis[0][0],xyz_list,gauss);
@@ -5875,16 +6612,16 @@
 	/*Build LprimeFS: */
 	for(int i=0;i<3;i++){
-		LprimeFS[num_dof_total*0+num_dof*i+0] = L1L2l3[i];
+		LprimeFS[num_dof_total*0+num_dof*i+0] = basis[i];
 		LprimeFS[num_dof_total*0+num_dof*i+1] = 0.;
 		LprimeFS[num_dof_total*0+num_dof*i+2] = 0.;
 		LprimeFS[num_dof_total*1+num_dof*i+0] = 0.;
-		LprimeFS[num_dof_total*1+num_dof*i+1] = L1L2l3[i];
+		LprimeFS[num_dof_total*1+num_dof*i+1] = basis[i];
 		LprimeFS[num_dof_total*1+num_dof*i+2] = 0.;
 		LprimeFS[num_dof_total*2+num_dof*i+0] = 0.;
 		LprimeFS[num_dof_total*2+num_dof*i+1] = 0.;
-		LprimeFS[num_dof_total*2+num_dof*i+2] = L1L2l3[i];
+		LprimeFS[num_dof_total*2+num_dof*i+2] = basis[i];
 		LprimeFS[num_dof_total*3+num_dof*i+0] = 0.;
 		LprimeFS[num_dof_total*3+num_dof*i+1] = 0.;
-		LprimeFS[num_dof_total*3+num_dof*i+2] = L1L2l3[i];
+		LprimeFS[num_dof_total*3+num_dof*i+2] = basis[i];
 		LprimeFS[num_dof_total*4+num_dof*i+0] = 0.;
 		LprimeFS[num_dof_total*4+num_dof*i+1] = 0.;
@@ -5933,6 +6670,6 @@
 		LprimeFS[num_dof_total*4+num_dof_vel+i] = 0.;
 		LprimeFS[num_dof_total*5+num_dof_vel+i] = 0.;
-		LprimeFS[num_dof_total*6+num_dof_vel+i] = L1L2l3[i];
-		LprimeFS[num_dof_total*7+num_dof_vel+i] = L1L2l3[i];
+		LprimeFS[num_dof_total*6+num_dof_vel+i] = basis[i];
+		LprimeFS[num_dof_total*7+num_dof_vel+i] = basis[i];
 	}
 	for(int i=3;i<6;i++){
@@ -5959,5 +6696,5 @@
 
 	int num_dof=3;
-	IssmDouble L1L2l3[3];
+	IssmDouble basis[3];
 
 	/*Cast gauss to GaussPenta*/
@@ -5965,23 +6702,23 @@
 	GaussPenta* gauss = dynamic_cast<GaussPenta*>(gauss_in);
 
-	/*Get L1L2l3 in actual coordinate system: */
-	L1L2l3[0]=gauss->coord1*(1-gauss->coord4)/2.0;
-	L1L2l3[1]=gauss->coord2*(1-gauss->coord4)/2.0;
-	L1L2l3[2]=gauss->coord3*(1-gauss->coord4)/2.0;
+	/*Get basis in actual coordinate system: */
+	basis[0]=gauss->coord1*(1-gauss->coord4)/2.0;
+	basis[1]=gauss->coord2*(1-gauss->coord4)/2.0;
+	basis[2]=gauss->coord3*(1-gauss->coord4)/2.0;
 
 	/*Build LFS: */
 	for(int i=0;i<3;i++){
-		LFS[num_dof*3*0+num_dof*i+0] = L1L2l3[i];
+		LFS[num_dof*3*0+num_dof*i+0] = basis[i];
 		LFS[num_dof*3*0+num_dof*i+1] = 0.;
 		LFS[num_dof*3*0+num_dof*i+2] = 0.;
 		LFS[num_dof*3*1+num_dof*i+0] = 0.;
-		LFS[num_dof*3*1+num_dof*i+1] = L1L2l3[i];
+		LFS[num_dof*3*1+num_dof*i+1] = basis[i];
 		LFS[num_dof*3*1+num_dof*i+2] = 0.;
 		LFS[num_dof*3*2+num_dof*i+0] = 0.;
 		LFS[num_dof*3*2+num_dof*i+1] = 0.;
-		LFS[num_dof*3*2+num_dof*i+2] = L1L2l3[i];
+		LFS[num_dof*3*2+num_dof*i+2] = basis[i];
 		LFS[num_dof*3*3+num_dof*i+0] = 0.;
 		LFS[num_dof*3*3+num_dof*i+1] = 0.;
-		LFS[num_dof*3*3+num_dof*i+2] = L1L2l3[i];
+		LFS[num_dof*3*3+num_dof*i+2] = basis[i];
 	}
 }/*}}}*/
@@ -5997,5 +6734,5 @@
 	 */
 	int num_dof=2;
-	IssmDouble L1L2l3[3];
+	IssmDouble basis[3];
 
 	/*Cast gauss to GaussPenta*/
@@ -6003,19 +6740,19 @@
 	GaussPenta* gauss = dynamic_cast<GaussPenta*>(gauss_in);
 
-	/*Get L1L2l3 in actual coordinate system: */
-	L1L2l3[0]=gauss->coord1*(1-gauss->coord4)/2.0;
-	L1L2l3[1]=gauss->coord2*(1-gauss->coord4)/2.0;
-	L1L2l3[2]=gauss->coord3*(1-gauss->coord4)/2.0;
+	/*Get basis in actual coordinate system: */
+	basis[0]=gauss->coord1*(1-gauss->coord4)/2.0;
+	basis[1]=gauss->coord2*(1-gauss->coord4)/2.0;
+	basis[2]=gauss->coord3*(1-gauss->coord4)/2.0;
 
 	/*Build LprimeFS: */
 	for(int i=0;i<3;i++){
-		LprimeFS[num_dof*3*0+num_dof*i+0] = L1L2l3[i];
+		LprimeFS[num_dof*3*0+num_dof*i+0] = basis[i];
 		LprimeFS[num_dof*3*0+num_dof*i+1] = 0.;
 		LprimeFS[num_dof*3*1+num_dof*i+0] = 0.;
-		LprimeFS[num_dof*3*1+num_dof*i+1] = L1L2l3[i];
-		LprimeFS[num_dof*3*2+num_dof*i+0] = L1L2l3[i];
+		LprimeFS[num_dof*3*1+num_dof*i+1] = basis[i];
+		LprimeFS[num_dof*3*2+num_dof*i+0] = basis[i];
 		LprimeFS[num_dof*3*2+num_dof*i+1] = 0.;
 		LprimeFS[num_dof*3*3+num_dof*i+0] = 0.;
-		LprimeFS[num_dof*3*3+num_dof*i+1] = L1L2l3[i];
+		LprimeFS[num_dof*3*3+num_dof*i+1] = basis[i];
 	}
 }/*}}}*/
Index: issm/trunk/src/c/analyses/StressbalanceAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/StressbalanceAnalysis.h	(revision 18081)
+++ issm/trunk/src/c/analyses/StressbalanceAnalysis.h	(revision 18301)
@@ -27,4 +27,5 @@
 		ElementVector* CreatePVector(Element* element);
 		void GetSolutionFromInputs(Vector<IssmDouble>* solution,Element* element);
+		void GradientJ(Vector<IssmDouble>* gradient,Element* element,int control_type,int control_index);
 		void GetSolutionFromInputsHoriz(Vector<IssmDouble>* solution,Element* element);
 		void InputUpdateFromSolution(IssmDouble* solution,Element* element);
@@ -36,4 +37,5 @@
 		ElementMatrix* CreateKMatrixSSAViscous(Element* element);
 		ElementMatrix* CreateKMatrixSSAFriction(Element* element);
+		ElementMatrix* CreateKMatrixSSALateralFriction(Element* element);
 		ElementVector* CreatePVectorSSA(Element* element);
 		ElementVector* CreatePVectorSSADrivingStress(Element* element);
@@ -67,4 +69,5 @@
 		ElementMatrix* CreateJacobianMatrixFS(Element* element);
 		ElementMatrix* CreateKMatrixFS(Element* element);
+		ElementMatrix* CreateKMatrixFSViscousLATH(Element* element);
 		ElementMatrix* CreateKMatrixFSViscousXTH(Element* element);
 		ElementMatrix* CreateKMatrixFSViscous(Element* element);
@@ -73,10 +76,19 @@
 		ElementVector* CreatePVectorFS(Element* element);
 		ElementVector* CreatePVectorFSViscous(Element* element);
+		ElementVector* CreatePVectorFSViscousLATH(Element* element);
 		ElementVector* CreatePVectorFSViscousXTH(Element* element);
 		ElementVector* CreatePVectorFSShelf(Element* element);
 		ElementVector* CreatePVectorFSFront(Element* element);
+		ElementVector* CreatePVectorFSFriction(Element* element);
+		ElementVector* CreatePVectorFSStress(Element* element);
 		void GetBFS(IssmDouble* B,Element* element,int dim,IssmDouble* xyz_list,Gauss* gauss);
 		void GetBFSprime(IssmDouble* B,Element* element,int dim,IssmDouble* xyz_list,Gauss* gauss);
+		void GetBFSvel(IssmDouble* B,Element* element,int dim,IssmDouble* xyz_list,Gauss* gauss);
+		void GetBFSprimevel(IssmDouble* B,Element* element,int dim,IssmDouble* xyz_list,Gauss* gauss);
 		void GetBFSFriction(IssmDouble* B,Element* element,int dim,IssmDouble* xyz_list,Gauss* gauss);
+		void GetBFSUzawa(IssmDouble* B,Element* element,int dim,IssmDouble* xyz_list,Gauss* gauss);
+		void GetBFSprimeUzawa(IssmDouble* B,Element* element,int dim,IssmDouble* xyz_list,Gauss* gauss);
+		void GetCFS(IssmDouble* B,Element* element,int dim,IssmDouble* xyz_list,Gauss* gauss);
+		void GetCFSprime(IssmDouble* B,Element* element,int dim,IssmDouble* xyz_list,Gauss* gauss);
 		void GetSolutionFromInputsFS(Vector<IssmDouble>* solution,Element* element);
 		void InputUpdateFromSolutionFS(IssmDouble* solution,Element* element);
Index: issm/trunk/src/c/analyses/StressbalanceSIAAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/StressbalanceSIAAnalysis.cpp	(revision 18081)
+++ issm/trunk/src/c/analyses/StressbalanceSIAAnalysis.cpp	(revision 18301)
@@ -40,4 +40,5 @@
 	iomodel->FetchDataToInput(elements,ThicknessEnum);
 	iomodel->FetchDataToInput(elements,FrictionCoefficientEnum);
+	iomodel->FetchDataToInput(elements,MaskGroundediceLevelsetEnum);
 	if(islevelset){
 		iomodel->FetchDataToInput(elements,IceMaskNodeActivationEnum);
@@ -493,4 +494,7 @@
 	xDelete<IssmDouble>(values);
 }/*}}}*/
+void StressbalanceSIAAnalysis::GradientJ(Vector<IssmDouble>* gradient,Element* element,int control_type,int control_index){/*{{{*/
+	_error_("Not implemented yet");
+}/*}}}*/
 void StressbalanceSIAAnalysis::InputUpdateFromSolution(IssmDouble* solution,Element* element){/*{{{*/
 
Index: issm/trunk/src/c/analyses/StressbalanceSIAAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/StressbalanceSIAAnalysis.h	(revision 18081)
+++ issm/trunk/src/c/analyses/StressbalanceSIAAnalysis.h	(revision 18301)
@@ -31,4 +31,5 @@
 		ElementVector* CreatePVector3D(Element* element);
 		void GetSolutionFromInputs(Vector<IssmDouble>* solution,Element* element);
+		void GradientJ(Vector<IssmDouble>* gradient,Element* element,int control_type,int control_index);
 		void InputUpdateFromSolution(IssmDouble* solution,Element* element);
 		void UpdateConstraints(FemModel* femmodel);
Index: issm/trunk/src/c/analyses/StressbalanceVerticalAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/StressbalanceVerticalAnalysis.cpp	(revision 18081)
+++ issm/trunk/src/c/analyses/StressbalanceVerticalAnalysis.cpp	(revision 18301)
@@ -38,5 +38,6 @@
 		iomodel->FetchDataToInput(elements,MeshVertexonsurfaceEnum);
 	}
-	iomodel->FetchDataToInput(elements,BasalforcingsMeltingRateEnum);
+	iomodel->FetchDataToInput(elements,BasalforcingsGroundediceMeltingRateEnum);
+	iomodel->FetchDataToInput(elements,BasalforcingsFloatingiceMeltingRateEnum);
 	iomodel->FetchDataToInput(elements,VxEnum,0.);
 	iomodel->FetchDataToInput(elements,VyEnum,0.);
@@ -278,5 +279,6 @@
 	IssmDouble *xyz_list_base = NULL;
 	IssmDouble  Jdet,slope[3];
-	IssmDouble  vx,vy,vz=0.,dbdx,dbdy,basalmeltingvalue;
+	IssmDouble  vx,vy,vz=0.,dbdx,dbdy;
+	IssmDouble  gmb,fmb,phi,basalmeltingvalue;
 
 	if(!element->IsOnBase()) return NULL;
@@ -293,8 +295,10 @@
 	element->GetVerticesCoordinatesBase(&xyz_list_base);
 	element->GetInputValue(&approximation,ApproximationEnum);
-	Input* base_input=element->GetInput(BaseEnum);                                _assert_(base_input);
-	Input* basal_melting_input=element->GetInput(BasalforcingsMeltingRateEnum); _assert_(basal_melting_input);
-	Input* vx_input=element->GetInput(VxEnum);                                  _assert_(vx_input);
-	Input* vy_input=element->GetInput(VyEnum);                                  _assert_(vy_input);
+	Input* base_input=element->GetInput(BaseEnum);                                               _assert_(base_input);
+	Input* groundedice_input=element->GetInput(MaskGroundediceLevelsetEnum);                     _assert_(groundedice_input);
+	Input* groundedice_melting_input=element->GetInput(BasalforcingsGroundediceMeltingRateEnum); _assert_(groundedice_melting_input);
+	Input* floatingice_melting_input=element->GetInput(BasalforcingsFloatingiceMeltingRateEnum); _assert_(floatingice_melting_input);
+	Input* vx_input=element->GetInput(VxEnum);                                                   _assert_(vx_input);
+	Input* vy_input=element->GetInput(VyEnum);                                                   _assert_(vy_input);
 	Input* vzFS_input=NULL;
 	if(approximation==HOFSApproximationEnum || approximation==SSAFSApproximationEnum){
@@ -307,5 +311,7 @@
 		gauss->GaussPoint(ig);
 
-		basal_melting_input->GetInputValue(&basalmeltingvalue,gauss);
+		groundedice_melting_input->GetInputValue(&gmb,gauss);
+		floatingice_melting_input->GetInputValue(&fmb,gauss);
+		groundedice_input->GetInputValue(&phi,gauss);
 		base_input->GetInputDerivativeValue(&slope[0],xyz_list,gauss);
 		vx_input->GetInputValue(&vx,gauss);
@@ -316,4 +322,6 @@
 		dbdx=slope[0];
 		dbdy=slope[1];
+		if(phi>0.) basalmeltingvalue=gmb;
+		else basalmeltingvalue=fmb;
 
 		element->JacobianDeterminantBase(&Jdet,xyz_list_base,gauss);
@@ -356,4 +364,7 @@
 void StressbalanceVerticalAnalysis::GetSolutionFromInputs(Vector<IssmDouble>* solution,Element* element){/*{{{*/
 	element->GetSolutionFromInputsOneDof(solution,VzEnum);
+}/*}}}*/
+void StressbalanceVerticalAnalysis::GradientJ(Vector<IssmDouble>* gradient,Element* element,int control_type,int control_index){/*{{{*/
+	_error_("Not implemented yet");
 }/*}}}*/
 void StressbalanceVerticalAnalysis::InputUpdateFromSolution(IssmDouble* solution,Element* element){/*{{{*/
Index: issm/trunk/src/c/analyses/StressbalanceVerticalAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/StressbalanceVerticalAnalysis.h	(revision 18081)
+++ issm/trunk/src/c/analyses/StressbalanceVerticalAnalysis.h	(revision 18301)
@@ -33,4 +33,5 @@
 		void GetBprime(IssmDouble* B,Element* element,IssmDouble* xyz_list,Gauss* gauss);
 		void GetSolutionFromInputs(Vector<IssmDouble>* solution,Element* element);
+		void GradientJ(Vector<IssmDouble>* gradient,Element* element,int control_type,int control_index);
 		void InputUpdateFromSolution(IssmDouble* solution,Element* element);
 		void UpdateConstraints(FemModel* femmodel);
Index: issm/trunk/src/c/analyses/ThermalAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/ThermalAnalysis.cpp	(revision 18081)
+++ issm/trunk/src/c/analyses/ThermalAnalysis.cpp	(revision 18301)
@@ -75,11 +75,4 @@
 	InputUpdateFromConstantx(elements,0.,VyMeshEnum);
 	InputUpdateFromConstantx(elements,0.,VzMeshEnum);
-	if(dakota_analysis){
-		elements->InputDuplicate(TemperatureEnum,QmuTemperatureEnum);
-		elements->InputDuplicate(BasalforcingsMeltingRateEnum,QmuMeltingEnum);
-		elements->InputDuplicate(VxMeshEnum,QmuVxMeshEnum);
-		elements->InputDuplicate(VxMeshEnum,QmuVyMeshEnum);
-		elements->InputDuplicate(VxMeshEnum,QmuVzMeshEnum);
-	}
 	if(islevelset){
 		iomodel->FetchDataToInput(elements,IceMaskNodeActivationEnum);
@@ -653,4 +646,7 @@
 	/*Clean-up*/
 	xDelete<IssmDouble>(dbasis);
+}/*}}}*/
+void ThermalAnalysis::GradientJ(Vector<IssmDouble>* gradient,Element* element,int control_type,int control_index){/*{{{*/
+	_error_("Not implemented yet");
 }/*}}}*/
 void ThermalAnalysis::InputUpdateFromSolution(IssmDouble* solution,Element* element){/*{{{*/
Index: issm/trunk/src/c/analyses/ThermalAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/ThermalAnalysis.h	(revision 18081)
+++ issm/trunk/src/c/analyses/ThermalAnalysis.h	(revision 18301)
@@ -35,4 +35,5 @@
 		void GetBAdvecprime(IssmDouble* B,Element* element,IssmDouble* xyz_list,Gauss* gauss);
 		void GetSolutionFromInputs(Vector<IssmDouble>* solution,Element* element);
+		void GradientJ(Vector<IssmDouble>* gradient,Element* element,int control_type,int control_index);
 		void InputUpdateFromSolution(IssmDouble* solution,Element* element);
 		void UpdateConstraints(FemModel* femmodel);
Index: issm/trunk/src/c/analyses/UzawaPressureAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/UzawaPressureAnalysis.cpp	(revision 18301)
+++ issm/trunk/src/c/analyses/UzawaPressureAnalysis.cpp	(revision 18301)
@@ -0,0 +1,277 @@
+#include "./UzawaPressureAnalysis.h"
+#include "../toolkits/toolkits.h"
+#include "../classes/classes.h"
+#include "../shared/shared.h"
+#include "../modules/modules.h"
+
+/*Model processing*/
+int  UzawaPressureAnalysis::DofsPerNode(int** doflist,int domaintype,int approximation){/*{{{*/
+	return 1;
+}/*}}}*/
+void UzawaPressureAnalysis::UpdateParameters(Parameters* parameters,IoModel* iomodel,int solution_enum,int analysis_enum){/*{{{*/
+
+	parameters->AddObject(iomodel->CopyConstantObject(AugmentedLagrangianRhopEnum));
+	parameters->AddObject(iomodel->CopyConstantObject(AugmentedLagrangianRholambdaEnum));
+}/*}}}*/
+void UzawaPressureAnalysis::UpdateElements(Elements* elements,IoModel* iomodel,int analysis_counter,int analysis_type){/*{{{*/
+
+	/*Update elements: */
+	int finiteelement = P1Enum;
+	int counter=0;
+	for(int i=0;i<iomodel->numberofelements;i++){
+		if(iomodel->my_elements[i]){
+			Element* element=(Element*)elements->GetObjectByOffset(counter);
+			element->Update(i,iomodel,analysis_counter,analysis_type,finiteelement);
+			counter++;
+		}
+	}
+
+	iomodel->FetchDataToInput(elements,VxEnum,0.);
+	iomodel->FetchDataToInput(elements,VyEnum,0.);
+	if(iomodel->domaintype==Domain3DEnum) iomodel->FetchDataToInput(elements,VzEnum,0.);
+	iomodel->FetchDataToInput(elements,PressureEnum,0.);
+	InputUpdateFromConstantx(elements,0.,SigmaNNEnum);
+}/*}}}*/
+void UzawaPressureAnalysis::CreateNodes(Nodes* nodes,IoModel* iomodel){/*{{{*/
+
+	int finiteelement = P1Enum;
+	::CreateNodes(nodes,iomodel,UzawaPressureAnalysisEnum,finiteelement);
+}/*}}}*/
+void UzawaPressureAnalysis::CreateConstraints(Constraints* constraints,IoModel* iomodel){/*{{{*/
+	return;
+}/*}}}*/
+void UzawaPressureAnalysis::CreateLoads(Loads* loads, IoModel* iomodel){/*{{{*/
+	return;
+}/*}}}*/
+
+/*Finite Element Analysis*/
+void           UzawaPressureAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
+ElementVector* UzawaPressureAnalysis::CreateDVector(Element* element){/*{{{*/
+	/*Default, return NULL*/
+	return NULL;
+}/*}}}*/
+ElementMatrix* UzawaPressureAnalysis::CreateJacobianMatrix(Element* element){/*{{{*/
+_error_("Not implemented");
+}/*}}}*/
+ElementMatrix* UzawaPressureAnalysis::CreateKMatrix(Element* element){/*{{{*/
+
+	/*Intermediaries*/
+	IssmDouble  D_scalar,Jdet;
+	IssmDouble *xyz_list = NULL;
+	int numnodes = element->GetNumberOfNodes();
+
+	/*Initialize Element matrix and vectors*/
+	ElementMatrix* Ke   = element->NewElementMatrix();
+	IssmDouble*    M    = xNew<IssmDouble>(numnodes);
+
+	/*Retrieve all inputs and parameters*/
+	element->GetVerticesCoordinates(&xyz_list);
+
+	Gauss* gauss = element->NewGauss(5);
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
+		gauss->GaussPoint(ig);
+
+		element->JacobianDeterminant(&Jdet,xyz_list,gauss);
+		this->GetM(M,element,gauss);
+		D_scalar=gauss->weight*Jdet;
+		TripleMultiply(M,1,numnodes,1,
+					&D_scalar,1,1,0,
+					M,1,numnodes,0,
+					&Ke->values[0],1);
+	}
+
+	/*Clean up and return*/
+	delete gauss;
+	xDelete<IssmDouble>(xyz_list);
+	xDelete<IssmDouble>(M);
+	return Ke;
+}/*}}}*/
+ElementVector* UzawaPressureAnalysis::CreatePVector(Element* element){/*{{{*/
+
+	/*Intermediaries*/
+	int          dim;
+	IssmDouble   Jdet,rhop,divu;
+	IssmDouble   *xyz_list = NULL;
+	int numnodes = element->GetNumberOfNodes();
+
+	/*Retrieve all inputs and parameters*/
+	element->FindParam(&dim,DomainDimensionEnum);
+	element->FindParam(&rhop,AugmentedLagrangianRhopEnum);
+	element->GetVerticesCoordinates(&xyz_list);
+
+	/*Initialize Element matrix and vectors*/
+	ElementVector* pe    = element->NewElementVector();
+	IssmDouble*    basis = xNew<IssmDouble>(numnodes);
+	IssmDouble*    dvx   = xNew<IssmDouble>(dim);
+	IssmDouble*    dvy   = xNew<IssmDouble>(dim);
+	IssmDouble*    dvz   = xNew<IssmDouble>(dim);
+
+	Input* vx_input=element->GetInput(VxEnum);     _assert_(vx_input);
+	Input* vy_input=element->GetInput(VyEnum);     _assert_(vy_input);
+	Input* vz_input = NULL;
+	if(dim==3){vz_input=element->GetInput(VzEnum); _assert_(vz_input);}
+
+	Gauss* gauss = element->NewGauss(5);
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
+		gauss->GaussPoint(ig);
+
+		element->JacobianDeterminant(&Jdet,xyz_list,gauss);
+		element->NodalFunctions(basis, gauss);
+		vx_input->GetInputDerivativeValue(&dvx[0],xyz_list,gauss);
+		vy_input->GetInputDerivativeValue(&dvy[0],xyz_list,gauss);
+		if(dim==3){
+			vz_input->GetInputDerivativeValue(&dvz[0],xyz_list,gauss);
+		}
+
+		divu=dvx[0]+dvy[1];
+		if (dim==3) divu=divu+dvz[2];
+
+		for(int i=0;i<numnodes;i++){
+			pe->values[i] += - rhop * divu * Jdet * gauss->weight * basis[i];
+		}
+	}
+
+	/*Clean up and return*/
+	delete gauss;
+	xDelete<IssmDouble>(xyz_list);
+	xDelete<IssmDouble>(basis);
+	xDelete<IssmDouble>(dvx);
+	xDelete<IssmDouble>(dvy);
+	xDelete<IssmDouble>(dvz);
+	return pe;
+}/*}}}*/
+void UzawaPressureAnalysis::GetM(IssmDouble* M,Element* element,Gauss* gauss){/*{{{*/
+	/*Compute B  matrix. M=[M1 M2 M3] */
+
+	/*Fetch number of nodes for this finite element*/
+	int numnodes = element->GetNumberOfNodes();
+
+	/*Get nodal functions*/
+	IssmDouble* basis=xNew<IssmDouble>(numnodes);
+	element->NodalFunctions(basis,gauss);
+
+	/*Build B: */
+	for(int i=0;i<numnodes;i++){
+		M[i] = basis[i];
+	}
+
+	/*Clean-up*/
+	xDelete<IssmDouble>(basis);
+}/*}}}*/
+void UzawaPressureAnalysis::GetSolutionFromInputs(Vector<IssmDouble>* solution,Element* element){/*{{{*/
+	_error_("not implemented yet");
+}/*}}}*/
+void UzawaPressureAnalysis::GradientJ(Vector<IssmDouble>* gradient,Element* element,int control_type,int control_index){/*{{{*/
+	_error_("Not implemented yet");
+}/*}}}*/
+void UzawaPressureAnalysis::InputUpdateFromSolution(IssmDouble* solution,Element* element){/*{{{*/
+
+	int        dim;
+	int        *doflist       = NULL;
+	IssmDouble rholambda,un,vx,vy,vz,sigmann;
+	IssmDouble *xyz_list_base = NULL;
+
+	/*Fetch number of nodes and dof for this finite element*/
+	int numnodes      = element->GetNumberOfNodes();
+	int numnodessigma = element->GetNumberOfNodes(P2Enum);
+
+	element->FindParam(&dim,DomainDimensionEnum);
+
+	/*Fetch dof list and allocate solution vector*/
+	element->GetDofList(&doflist,NoneApproximationEnum,GsetEnum);
+	IssmDouble* values        = xNew<IssmDouble>(numnodes);
+	IssmDouble* valueslambda  = xNewZeroInit<IssmDouble>(numnodessigma);
+	IssmDouble* pressure      = xNew<IssmDouble>(numnodes);
+	Input* sigmann_input      = element->GetInput(SigmaNNEnum); _assert_(sigmann_input);
+	Input* vx_input           = element->GetInput(VxEnum);      _assert_(vx_input);
+	Input* vy_input           = element->GetInput(VyEnum);      _assert_(vy_input);
+	Input* vz_input           = NULL;
+	if(dim==3){vz_input       = element->GetInput(VzEnum);      _assert_(vz_input);}
+	element->GetInputListOnNodes(&pressure[0],PressureEnum);
+
+	/*Update pressure enum first*/
+	for(int i=0;i<numnodes;i++){
+		values[i]  = pressure[i] + solution[doflist[i]];
+	}
+	element->AddInput(PressureEnum,values,element->GetElementType());
+
+	/*Now compute sigmann if on base*/
+	if(element->IsOnBase()){ 
+		if(dim==3) _error_("not implemented yet");
+
+		int baselist[3];
+		int onbase=0;
+		IssmDouble  Jdet;
+		IssmDouble bed_normal[3];
+		IssmDouble  Jlambda[3][3]  = {0.0};
+		IssmDouble  Cuk[3]         = {0.0};
+		IssmDouble  deltalambda[3] = {0.0};
+		IssmDouble* vertexonbase  = xNew<IssmDouble>(numnodessigma);
+		Input* vertexonbase_input = element->GetInput(MeshVertexonbaseEnum); _assert_(vertexonbase_input);
+		Gauss* gauss = element->NewGauss();
+
+		IssmDouble* basis = xNewZeroInit<IssmDouble>(numnodessigma);
+		element->GetVerticesCoordinatesBase(&xyz_list_base);
+		element->NormalBase(&bed_normal[0],xyz_list_base);
+		element->FindParam(&rholambda,AugmentedLagrangianRholambdaEnum);
+
+		for(int i=0;i<numnodessigma;i++){
+			gauss->GaussNode(P2Enum,i);
+			vertexonbase_input->GetInputValue(&vertexonbase[i], gauss);
+			if(vertexonbase[i]==1){ 
+				baselist[onbase]=i;
+				onbase += 1;
+			}
+		}
+		if(onbase!=3) _error_("basal nodes of element not found");
+
+		delete gauss;
+		gauss = element->NewGaussBase(3);
+		for(int ig=gauss->begin();ig<gauss->end();ig++){
+			gauss->GaussPoint(ig);
+
+			/*Compute Jlambda*/
+			element->NodalFunctionsP2(basis,gauss);
+			element->JacobianDeterminantBase(&Jdet,xyz_list_base,gauss);
+			for(int i=0;i<3;i++){
+				for(int j=0;j<3;j++){
+					Jlambda[i][j] += Jdet*gauss->weight*basis[baselist[i]]*basis[baselist[j]];
+				}
+			}
+
+			/*Compute rho_lambd C u^k*/
+			vx_input->GetInputValue(&vx, gauss);
+			vy_input->GetInputValue(&vy, gauss);
+			un=bed_normal[0]*vx + bed_normal[1]*vy;
+			for(int i=0;i<3;i++) Cuk[i] += - un*rholambda*Jdet*gauss->weight*basis[baselist[i]];
+		}
+
+		/*Now update sigmann*/
+		Matrix3x3Solve(&deltalambda[0],&Jlambda[0][0],&Cuk[0]);
+		delete gauss;
+		gauss = element->NewGauss();
+		for(int i=0;i<3;i++){
+			gauss->GaussNode(P2Enum,baselist[i]);
+			sigmann_input->GetInputValue(&sigmann, gauss);
+			valueslambda[baselist[i]] = sigmann + deltalambda[i];
+		}
+
+		delete gauss;
+		xDelete<IssmDouble>(vertexonbase);
+		xDelete<IssmDouble>(xyz_list_base);
+		xDelete<IssmDouble>(basis);
+	}
+	element->AddInput(SigmaNNEnum,valueslambda,P2Enum);
+
+	/*Free ressources:*/
+	xDelete<IssmDouble>(values);
+	xDelete<IssmDouble>(valueslambda);
+	xDelete<IssmDouble>(pressure);
+	xDelete<int>(doflist);
+}/*}}}*/
+void UzawaPressureAnalysis::UpdateConstraints(FemModel* femmodel){/*{{{*/
+	/*Default, do nothing*/
+	return;
+}/*}}}*/
